#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <algorithm>
#include <vector>
 
using namespace std;
 
#define NMAX 20
#define INF 1000000000
#define TIME_LIMIT 0.48
 
int A[NMAX][NMAX], deg[NMAX];
int N, sum, tend;
 
void ReadInput() {
    int i, j, c, k, M;
 
    freopen("mmo.in", "r", stdin);
    scanf("%d %d", &N, &M);
 
    for (i = 1; i <= N; i++)
        for (j = 1; j <= N; j++)
            A[i][j] = INF;
 
    for (i = 1; i <= N; i++)
        A[i][i] = deg[i] = 0;
 
    for (k = 1; k <= M; k++) {
        scanf("%d %d %d", &i, &j, &c);
        A[i][j] = A[j][i] = c;
        deg[i]++; deg[j]++;
        sum += c;
    }
}
 
void RoyFloyd() {
    int i, j, k;
    for (k = 1; k <= N; k++)
        for (i = 1; i <= N; i++)
            for (j = 1; j <= N; j++)
                if (A[i][k] + A[k][j] < A[i][j])
                    A[i][j] = A[i][k] + A[k][j];
}
 
int odd[NMAX], nodd, matched[NMAX], cmin, ccmin;
vector<pair<int, int> > v[NMAX];
 
void BKT(int i) {
    if (i > nodd) {
        if (ccmin < cmin)
            cmin = ccmin;
    } else {
        if (matched[i])
            BKT(i + 1);
        else {
            int j, k;
            matched[i] = 1;
 
            if (i > 0) {
                for (j = i + 1; j <= nodd; j++)
                    if (!matched[j]) {
                        ccmin += A[odd[i]][odd[j]];
                        matched[j] = 1;
                        if (ccmin < cmin)
                            BKT(i + 1);
                        matched[j] = 0;
                        ccmin -= A[odd[i]][odd[j]];
                        if (clock() >= tend)
                            return;
                    }
            } else {
                v[i].clear();
                for (j = i + 1; j <= nodd; j++)
                    if (!matched[j])
                        v[i].push_back(make_pair(A[odd[i]][odd[j]], j));
                sort(v[i].begin(), v[i].end());
                for (k = 0; k < v[i].size(); k++) {
                    j = v[i][k].second;
                    ccmin += v[i][k].first;
                    matched[j] = 1;
                    if (ccmin < cmin)
                        BKT(i + 1);
                    matched[j] = 0;
                    ccmin -= v[i][k].first;
                    if (clock() >= tend)
                        return;
                }
            }
 
            matched[i] = 0;
        }
    }
}
 
char selected[NMAX];
int nsel, maxnsel;
 
int flow[NMAX][NMAX], cost[NMAX][NMAX], used[NMAX], dmin[NMAX], inq[NMAX], t[NMAX], pa[NMAX], pflow[NMAX];
int q[NMAX * NMAX * NMAX];
vector<pair<int, int> > vv;
 
void MinCostMatching() {
    int i, j, k, p, r, li, ls, maxflow;
 
    memset(flow, 0, sizeof(flow));
    memset(cost, 0, sizeof(cost));
 
    for (p = 0, i = 1; i <= nodd; i++)
        if (selected[i]) {
            p++;
            for (r = 0, j = 1; j <= nodd; j++)
                if (!selected[j]) {
                    r++;
                    cost[p][nsel + r] = A[odd[i]][odd[j]];
                }
        }
 
    memset(used, 0, sizeof(used));
    memset(pflow, 0, sizeof(pflow));
 
    maxflow = 0;
    ccmin = 0;
 
    while (maxflow < nsel) {
        memset(inq, 0, sizeof(inq));
        memset(t, 0, sizeof(t));
        memset(pa, 0, sizeof(pa));
 
        for (i = 1; i <= nodd; i++)
            dmin[i] = INF;
 
        li = 1; ls = 0;
        for (i = 1; i <= nsel; i++)
            if (!used[i]) {
                ls++;
                q[ls] = i;
                inq[i] = 1;
                dmin[i] = 0;
            }
 
        while (li <= ls) {
            i = q[li];
            li++;
 
            if (i <= nsel) {
                for (j = nsel + 1; j <= nodd; j++)
                    if (flow[i][j] == 0) {
                        r = dmin[i] + cost[i][j];
                        if (r < dmin[j]) {
                            dmin[j] = r;
                            pa[j] = i;
                            t[j] = 1;
                            if (!inq[j]) {
                                ls++;
                                q[ls] = j;
                            }
                        }
                    }
            } else {
                if (pflow[i] > 0) {
                    r = dmin[i] - cost[pflow[i]][i];
                    if (r < dmin[pflow[i]]) {
                        dmin[pflow[i]] = r;
                        pa[pflow[i]] = i;
                        t[pflow[i]] = 2;
                        if (!inq[pflow[i]]) {
                            ls++;
                            q[ls] = pflow[i];
                        }
                    }
                }
            }
        }
 
        vv.clear();
        for (j = nsel + 1; j <= nodd; j++)
            if (dmin[j] < INF && !used[j])
                vv.push_back(make_pair(dmin[j], j));
 
        sort(vv.begin(), vv.end());
        memset(inq, 0, sizeof(inq));
 
        for (r = 0; r < vv.size(); r++) {
            p = vv[r].second;
            while (p > 0) {
                if (inq[p] > 0)
                    break;
                p = pa[p];
            }
 
            if (p > 0)
                continue;
 
            p = vv[r].second;
            ccmin += dmin[p];
 
            if (ccmin > cmin)
                return;
 
            used[p] = 1;
            while (p > 0) {
                inq[p] = 1;
                if (pa[p] == 0) {
                    used[p] = 1;
                    break;
                }
                if (t[p] == 1) {
                    pflow[p] = pa[p];
                    flow[pa[p]][p] = 1;
                } else {
                    flow[p][pa[p]] = 0;
                }
                p = pa[p];
            }
        }
 
        /*
        p = 0; r = INF;
        for (j = nsel + 1; j <= nodd; j++)
            if (dmin[j] < r && !used[j]) {
                r = dmin[j];
                p = j;
            }
 
        if (r == INF)
            exit(1);
 
        ccmin += dmin[p];
 
        if (ccmin > cmin)
            return;
 
        used[p] = 1;
        while (p > 0) {
            if (pa[p] == 0) {
                used[p] = 1;
                break;
            }
            if (t[p] == 1) {
                pflow[p] = pa[p];
                flow[pa[p]][p] = 1;
            } else {
                flow[p][pa[p]] = 0;
            }
 
            p = pa[p];
        }
        */
 
        maxflow++;
        //if (clock() >= tend)
        //    return;
    }
 
    for (i = 1; i <= nodd; i++)
        if (!used[i])
            exit(1);
 
    if (ccmin < cmin)
        cmin = ccmin;
}
 
void BKTMM(int i) {
    if (i > nodd) {
        if (nsel == maxnsel)
            MinCostMatching();
    } else {
        selected[i] = 1;
        nsel++;
        if (nsel <= maxnsel)
            BKTMM(i + 1);
        nsel--;
        selected[i] = 0;
        BKTMM(i + 1);
    }
}
 
void Solve() {
    int i, j, k;
 
    for (nodd = 0, i = 1; i <= N; i++)
        if (deg[i] % 2 == 1) {
            nodd++;
            odd[nodd] = i;
        }
 
    cmin = INF;
    ccmin = 0;
 
    if (nodd == 0) {
        cmin = 0;
        return;
    }
 
    //fprintf(stderr, "nodd=%d\n", nodd);
 
    //memset(matched, 0, sizeof(matched));
    //BKT(1);
 
    memset(selected, 0, sizeof(selected));
    nsel = 0;
    maxnsel = nodd / 2;
    BKTMM(1);
}
 
void WriteOutput() {
    freopen("mmo.out", "w", stdout);
    printf("%d\n", sum - cmin);
}
 
int main() {
    tend = (int) (clock() + TIME_LIMIT * CLOCKS_PER_SEC);
    ReadInput();
    RoyFloyd();
    Solve();
    WriteOutput();
    return 0;
}
