#include <stdio.h>
#include <string.h>
#include <stdlib.h>
 
#define NMAX 500100
#define DEBUG 0
 
int vvec[2 * NMAX], vstart[NMAX], vnext[2 * NMAX];
char c[NMAX], stmp[NMAX];
int N;
 
void ReadInt(int& x) {
    int poz = 0;
    while (stmp[poz] < '0' || stmp[poz] > '9')
        poz++;
    x = 0;
    while (stmp[poz] >= '0' && stmp[poz] <= '9') {
        x = x * 10 + stmp[poz] - '0';
        poz++;
    }
}
 
void Read2Ints(int& x, int& y) {
    int poz = 0;
    while (stmp[poz] < '0' || stmp[poz] > '9')
        poz++;
    x = 0;
    while (stmp[poz] >= '0' && stmp[poz] <= '9') {
        x = x * 10 + stmp[poz] - '0';
        poz++;
    }
    while (stmp[poz] < '0' || stmp[poz] > '9')
        poz++;
    y = 0;
    while (stmp[poz] >= '0' && stmp[poz] <= '9') {
        y = y * 10 + stmp[poz] - '0';
        poz++;
    }
}
 
void ReadInput() {
    int i, j, k, M = 0;
 
    freopen("parb.in", "r", stdin);
    c[0] = 0;
    fgets(stmp, NMAX - 2, stdin);
    ReadInt(N);
    fgets(c + 1, NMAX - 2, stdin);
 
    for (i = 1; i <= N; i++)
        vstart[i] = 0;
 
    for (k = 1; k < N; k++) {
        fgets(stmp, NMAX - 2, stdin);
        Read2Ints(i, j);
 
        M++;
        vvec[M] = j;
        vnext[M] = vstart[i];
        vstart[i] = M;
 
        M++;
        vvec[M] = i;
        vnext[M] = vstart[j];
        vstart[j] = M;
    }
}
 
char visited[NMAX];
int sons[NMAX], sonsnext[NMAX], sonsstart[NMAX];
int q[NMAX], li, ls;
 
void RootTree() {
    int i, j, k, M = 0;
    q[li = ls = 1] = 1;
 
    memset(visited, 0, sizeof(visited));
    visited[1] = 1;
 
    for (i = 1; i <= N; i++)
        sonsstart[i] = 0;
 
    while (li <= ls) {
        i = q[li];
        li++;
        for (k = vstart[i]; k > 0; k = vnext[k]) {
            j = vvec[k];
            if (!visited[j]) {
                ls++;
                q[ls] = j;
                visited[j] = 1;
 
                M++;
                sons[M] = j;
                sonsnext[M] = sonsstart[i];
                sonsstart[i] = M;
            }
        }
    }
}
 
char ch;
int fson[128], sson[NMAX], pp[NMAX];
int cand[2][NMAX], s[NMAX], M, ncand[2];
int pstart[2][NMAX];
unsigned long long h[NMAX];
 
#define P 997ULL
//#define Q 4000000007ULL
 
unsigned long long h1, h2, PP[NMAX];
 
void MergeSons() {
    int i, j, k, p, r, L, li, ls, mid;
 
    memset(pp, 0, sizeof(pp));
    memset(sson, 0, sizeof(sson));
 
    for (i = 1; i <= N; i++) {
        //if (DEBUG)
        //    fprintf(stderr, "node=%d nsons=%d\n", q[i], sons[q[i]].size());

		if (sson[q[i]] < 0)
			continue;
		
        for (ch = 'a'; ch <= 'z'; ch++)
            fson[ch] = 0;
 
        for (k = sonsstart[q[i]]; k > 0; k = sonsnext[k]) {
            j = sons[k];
 
            if (fson[c[j]] == 0)
                fson[c[j]] = j;
            else {
                p = sonsstart[j];
                if (p == 0)
                    continue;
                while (sonsnext[p] > 0)
                    p = sonsnext[p];
                sonsnext[p] = sonsstart[fson[c[j]]];
                sonsstart[fson[c[j]]] = sonsstart[j];
                sonsstart[j] = 0;
				sson[j] = -1;
            }
        }
 
        for (ch = 'z'; ch >= 'a'; ch--)
            if (fson[ch] > 0) {
                sson[q[i]] = fson[ch];
                pp[fson[ch]] = q[i];
                break;
            }
    }
  
    PP[0] = 1;
    PP[1] = P;
    for (i = 2; i <= N; i++)
        PP[i] = (PP[i - 1] * P); // % Q;
 
    ncand[0] = 0;
    for (i = 1; i <= N; i++)
        if (pp[i] == 0 && sson[i] >= 0) {
            M = 0;
            j = i;
            while (j > 0) {
                M++;
                s[M] = j;
                j = sson[j];
            }
 
            h[M + 1] = 0;
            h[M] = c[s[M]];
            p = M;
 
            for (j = M - 1; j >= 1; j--) {
                h[j] = (h[j + 1] * P + c[s[j]]); // % Q;
                if (DEBUG)
                    fprintf(stderr, "j=%d: hash=%llu\n", j, h[j]);
 
                // Check to see if the suffix starting at position j is lexicographically maximum.
                li = 1; ls = M - p + 1; r = 0;
                while (li <= ls) {
                    mid = (li + ls) >> 1;
                    h1 = (h[j + mid] * PP[mid]); // % Q;
                    h1 = (h[j] - h1); // % Q;
                    h2 = (h[p + mid] * PP[mid]); // % Q;
                    h2 = (h[p] - h2); // % Q;
                    if (h1 == h2) {
                        r = mid;
                        li = mid + 1;
                    } else {
                        ls = mid - 1;
                    }
                }
 
                if (DEBUG)
                    fprintf(stderr, "j=%d/%d p=%d r=%d\n", j, M, p, r);
 
                if (r == M - p + 1 || c[s[j + r]] > c[s[p + r]])
                    p = j;
            }
 
            if (DEBUG)
                fprintf(stderr, "M=%d p=%d (%d)\n", M, p, s[p]);
 
            ncand[0]++;
            cand[0][ncand[0]] = s[p];
            pstart[0][ncand[0]] = s[p];
        }
}
 
void SelectBest() {
    int i, j, curr = 0, prev = 0;
    char cmax;
 
    while (ncand[curr] > 1) {
        cmax = 0;
        for (i = 1; i <= ncand[curr]; i++)
            if (c[cand[curr][i]] > cmax)
                cmax = c[cand[curr][i]];
 
        if (cmax == 0)
            break;
 
        prev = curr;
        curr = 1 - curr;
        ncand[curr] = 0;
        for (i = 1; i <= ncand[prev]; i++)
            if (c[cand[prev][i]] == cmax) {
                ncand[curr]++;
                cand[curr][ncand[curr]] = sson[cand[prev][i]];
                pstart[curr][ncand[curr]] = pstart[prev][i];
            }
    }
 
    freopen("parb.out", "w", stdout);
    for (i = pstart[curr][1]; i > 0; ) {
        printf("%c", c[i]);
        i = sson[i];
    }
    printf("\n");
}
 
int main() {
    ReadInput();
    RootTree();
    MergeSons();
    SelectBest();
    return 0;
}
