#include <stdio.h>
#include <string.h>
 
#define NMAX 99
#define KMAX 18
#define DEBUG 0
 
int sol[NMAX], csol[NMAX], minsol, cminsol;
char A[NMAX][NMAX];
int N, M;
 
void ReadInput() {
    int i, j, k;
 
    freopen("rmvc.in", "r", stdin);
    scanf("%d %d", &N, &M);
    for (k = 1; k <= M; k++) {
        scanf("%d %d", &i, &j);
        A[i][j] = A[j][i] = 1;
    }
}
 
int level;
 
void BKT() {
    int degmax = 0, nodemax = 0, i, j, k, deg;
    for (i = 1; i <= N; i++) {
        deg = 0;
        for (j = 1; j <= N; j++)
            if (A[i][j] == 1)
                deg++;
        if (deg > degmax) {
            degmax = deg;
            nodemax = i;
        }
    }
 
    if (DEBUG) {
        fprintf(stderr, "level=%d degmax=%d nodemax=%d M=%d mindeg=%d cminsol=%d minsol=%d\n", level, degmax, nodemax, M, M / (minsol - cminsol), cminsol, minsol);
    }
 
    //if (degmax < M / (minsol - cminsol))
	//   return;
 
    if (degmax == 0) {
        minsol = cminsol;
        for (i = 1; i <= cminsol; i++)
            sol[i] = csol[i];
        return;
    }
 
    // Case 1: Select the max. degree node.
    cminsol++;
    csol[cminsol] = nodemax;
    if (cminsol < minsol) {
        for (j = 1; j <= N; j++)
            if (A[nodemax][j] == 1) {
                A[nodemax][j] = A[j][nodemax] = level;
                M--;
            }
 
        if (DEBUG)
            fprintf(stderr, "   selecting max. degree node %d: cminsol=%d\n", nodemax, cminsol);
 
        level++;
        BKT();
        level--;
        cminsol--;
 
        if (DEBUG)
            fprintf(stderr, "   selecting neighbors of max. degree node %d: cminsol=%d\n", nodemax, cminsol);
 
        // Select all the neighbors of the max. degree node.
		//fprintf(stderr, "  a: nodemax=%d cminsol=%d minsol=%d M=%d\n", nodemax, cminsol, minsol, M);

        for (j = 1; j <= N; j++)
            if (A[nodemax][j] == level) {
                cminsol++;
                csol[cminsol] = j;
				for (k = 1; k <= N; k++)
					if (A[j][k] == 1) {
						A[j][k] = A[k][j] = level;
						M--;
					}
				
				//fprintf(stderr, "   +%d %d\n", j, cminsol);
                if (DEBUG)
                    fprintf(stderr, "     neigh: %d\n", j);
            }
 
        if (cminsol < minsol) {
            level++;
            BKT();
            level--;
        }

		//fprintf(stderr, "  b: nodemax=%d cminsol=%d M=%d\n", nodemax, cminsol, M);
		
        for (j = 1; j <= N; j++)
            if (A[nodemax][j] == level) {
				for (k = 1; k <= N; k++)
					if (A[j][k] == level && k != nodemax) {
						A[j][k] = A[k][j] = 1;
						M--;
					}

                cminsol--;
                A[nodemax][j] = A[j][nodemax] = 1;
                M++;
				//fprintf(stderr, "   -%d %d\n", j, cminsol);
            }

		//fprintf(stderr, "  c: nodemax=%d cminsol=%d minsol=%d M=%d\n", nodemax, cminsol, minsol, M);
    } else
		cminsol--;
}
 
void WriteOutput() {
    int i;
    freopen("rmvc.out", "w", stdout);
    printf("%d\n", minsol);
    for (i = 1; i <= minsol; i++) {
        printf("%d", sol[i]);
        if (i < minsol)
        printf(" ");
    }
    printf("\n");
 
    if (DEBUG)
        fprintf(stderr, "minsol=%d M=%d\n", minsol, M);
}
 
int main() {
    ReadInput();
 
    minsol = KMAX + 1;
    cminsol = 0;
    level = 2;
    BKT();
 
    WriteOutput();
 
    return 0;
}
