#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#include <vector>
#include <set>
 
#define DEBUG 0
 
using namespace std;
 
#define QMAX 500100
 
int q[QMAX][3];
 
#define LMAX 10000
 
char stmp[LMAX];
int nread, neg;
 
int ReadInt(int& x, int poz) {
    while ((stmp[poz] < '0' || stmp[poz] > '9') && (stmp[poz] != '-'))
        poz++;

    x = nread = 0;
	neg = 0;
	if (stmp[poz] == '-') {
		neg = 1;
		poz++;
	}

    while (stmp[poz] >= '0' && stmp[poz] <= '9') {
        x = x * 10 + stmp[poz] - '0';
        poz++;
		nread++;
    }

	if (neg)
		x = -x;
	
	if (nread == 0)
		exit(1);
	
    return poz;
}
 
int Read2Ints(int& x, int& y, int poz) {
    while ((stmp[poz] < '0' || stmp[poz] > '9') && (stmp[poz] != '-'))
        poz++;

    x = nread = 0;
	neg = 0;
	if (stmp[poz] == '-') {
		neg = 1;
		poz++;
	}
	
    while (stmp[poz] >= '0' && stmp[poz] <= '9') {
        x = x * 10 + stmp[poz] - '0';
        poz++;
		nread++;
    }

	if (neg)
		x = -x;
	
	if (nread == 0)
		exit(1);

    while ((stmp[poz] < '0' || stmp[poz] > '9') && (stmp[poz] != '-'))
        poz++;

    y = nread = 0;
	neg = 0;
	if (stmp[poz] == '-') {
		neg = 1;
		poz++;
	}
 
	while (stmp[poz] >= '0' && stmp[poz] <= '9') {
        y = y * 10 + stmp[poz] - '0';
        poz++;
		nread++;
    }

	if (neg)
		y = -y;
	
	if (nread == 0)
		exit(1);

    return poz;
}
 
int nop;
 
void ReadInput() {
    int k, poz;
 
    freopen("timetravel.in", "r", stdin);
    fgets(stmp, LMAX - 2, stdin);
    ReadInt(nop, 0);
 
    for (k = 1; k <= nop; k++) {
        fgets(stmp, LMAX - 2, stdin);
        poz = ReadInt(q[k][0], 0);
 
        if (q[k][0] == 1 || q[k][0] == 3)
            ReadInt(q[k][1], poz);
        else
            Read2Ints(q[k][1], q[k][2], poz);
    }
}

#define TMAX 262144 //524288
multiset<int> vset[2 * TMAX];
multiset<int>::iterator it;
 
void Update(int value, int t, int op) {
    int node = TMAX + t - 1;
    while (node > 0) {
        if (op == 1) {
            vset[node].insert(value);
            //if (DEBUG)
            //    fprintf(stderr, "  insert into time segtree: node=%d vidx=%d\n", node, value);
        } else {
            it = vset[node].find(value);
            if (it == vset[node].end())
                exit(1);
            vset[node].erase(it);
            //if (DEBUG)
            //    fprintf(stderr, "  erase from time segtree: node=%d vidx=%d\n", node, value);
        }
        node >>= 1;
    }
}
 
int Query(int node, int lnode, int rnode, int A, int B, int value) {
    if (A <= lnode && rnode <= B) {
        //if (DEBUG)
        //    fprintf(stderr, "   query in time segtree: node=%d lnode=%d rnode=%d A=%d B=%d vidx=%d\n", node, lnode, rnode, A, B, value);
        if (vset[node].size() == 0)
			return 0;
		it = vset[node].lower_bound(value);
        if (it == vset[node].end())
            return 0;
        return *it;
    }
 
    int lson = 2 * node;
    int rson = lson + 1;
    int mid = (lnode + rnode) >> 1;
    int answer = 0;
 
    if (A <= mid) {
        answer = Query(lson, lnode, mid, A, B, value);
    }
 
    if (B >= mid + 1) {
        int tmpans = Query(rson, mid + 1, rnode, A, B, value);
        if (tmpans > 0 && (answer == 0 || answer > tmpans))
            answer = tmpans;
    }
 
    return answer;
}
 
#define VMAX 100100
multiset<int> tset[VMAX];
int active[VMAX];

vector<int> val, t, vu, tu;
 
void PreprocessInput() {
    int i, j, k;
 
    for (k = 1; k <= nop; k++) {
        if (q[k][0] == 1)
            val.push_back(q[k][1]);
        else if (q[k][0] == 2)
            t.push_back(q[k][1]);
    }
 
    sort(val.begin(), val.end());
    sort(t.begin(), t.end());
 
    vu.push_back(val[0]);
    for (i = 1; i < val.size(); i++)
        if (val[i] > val[i - 1])
            vu.push_back(val[i]);
 
    tu.push_back(t[0]);
    for (i = 1; i < t.size(); i++)
        if (t[i] > t[i - 1])
            tu.push_back(t[i]);
 
    val.clear();
    t.clear();
 
    for (i = 0; i < vu.size(); i++) {
        tset[i + 1].insert(tu.size() + 1);
        active[i + 1] = 0;
    }
}
 
int GetIndex(int value, const vector<int>& v) {
    int li = 0, ls = v.size() - 1, mid, ans = -1;
    while (li <= ls) {
        mid = (li + ls) >> 1;
        if (v[mid] <= value) {
			ans = mid;
            li = mid + 1;
        } else
            ls = mid - 1;
    }
 
    return ans + 1;
}
 
void InsertValue(int value) {
    int vidx = GetIndex(value, vu);
    int tidx = *(tset[vidx].begin());
    if (DEBUG)
        fprintf(stderr, "### InsertValue: value=%d(%d) tidx=%d\n", value, vidx, tidx);
 
    active[vidx]++;
    if (active[vidx] == 1) {
        Update(vidx, tidx, 1);
    }
}
 
void CancelInsertValue(int value) {
    int vidx = GetIndex(value, vu);
    int tidx = *(tset[vidx].begin());
    active[vidx]--;
    if (active[vidx] == 0) {
        Update(vidx, tidx, 0);
    }
    if (DEBUG)
        fprintf(stderr, "### CancelInsertValue: value=%d(%d) tidx=%d\n", value, vidx, tidx);
}
 
void EraseTimeValue(int time, int value) {
    int tidx = GetIndex(time, tu);
    int vidx = GetIndex(value, vu);

	if (vidx == 0 || vu[vidx - 1] != value)
		return;

    int terase = *(tset[vidx].begin());
 
    if (DEBUG)
        fprintf(stderr, "### EraseTimeValue: value=%d(%d) time=%d(%d) terase_idx=%d\n", value, vidx, time, tidx, terase);
 
    if (tidx < terase && active[vidx]) {
        Update(vidx, terase, 0);
        Update(vidx, tidx, 1);
    }
 
    tset[vidx].insert(tidx);
}
 
void CancelEraseTimeValue(int time, int value) {
    int tidx = GetIndex(time, tu);
    int vidx = GetIndex(value, vu);

	if (vidx == 0 || vu[vidx - 1] != value)
		return;

    int terase = *(tset[vidx].begin());
 
    if (DEBUG)
        fprintf(stderr, "### CancelEraseTimeValue: value=%d(%d) time=%d(%d) terase_idx=%d\n", value, vidx, time, tidx, terase);
 
    if (active[vidx])
        Update(vidx, terase, 0);
 
    it = tset[vidx].find(tidx);
    if (it != tset[vidx].end())
        tset[vidx].erase(it);
	else
		exit(1);
 
    if (active[vidx])
        Update(vidx, *(tset[vidx].begin()), 1);
}
 
void QueryTimeValue(int time, int value) {
    int tidx = GetIndex(time, tu);
    int vidx = GetIndex(value, vu);
 
	if (vidx == 0 || vu[vidx - 1] != value)
		vidx++;
	
    if (DEBUG)
        fprintf(stderr, "### QueryTimeValue: value=%d(%d) time=%d(%d)\n", value, vidx, time, tidx);
 
    int answer = Query(1, 1, TMAX, tidx + 1, TMAX, vidx);
    if (answer == 0)
        printf("Time paradox\n");
    else
        printf("%d\n", vu[answer - 1]);
}
 
void ProcessOperations() {
    int op;

    freopen("timetravel.out", "w", stdout);

    for (op = 1; op <= nop; op++) {
        if (q[op][0] == 1) {
            InsertValue(q[op][1]);
        } else if (q[op][0] == 2) {
            EraseTimeValue(q[op][1], q[op][2]);
        } else if (q[op][0] == 3) {
            CancelInsertValue(q[op][1]);
        } else if (q[op][0] == 4) {
            CancelEraseTimeValue(q[op][1], q[op][2]);
        } else if (q[op][0] == 5) {
            QueryTimeValue(q[op][1], q[op][2]);
        }
    }
}

int main() {
    ReadInput();
    PreprocessInput();
    ProcessOperations();
    return 0;
}
