#include <stdio.h>

#define LBMAX 128
#define BMAX 63

unsigned long long bitmod[LBMAX], bit[BMAX];
unsigned long long A, B, C;

void compute_bits() {
	bitmod[0] = 1 % C;
	for (int i = 1; i < LBMAX; i++) {
		bitmod[i] = (bitmod[i - 1] * 2) % C;
		//fprintf(stderr, "i=%d bitmod=%llu\n", i, bitmod[i]);
	}

	bit[0] = 1;
	for (int i = 1; i < BMAX; i++) {
		bit[i] = bit[i - 1] * 2;
	}
}

unsigned long long mult(unsigned long long X, unsigned long long Y) {
	unsigned long long result = 0;
	int i, j;

	//fprintf(stderr, "mult(%llu,%llu)\n", X, Y);
	for (i = 0; i < BMAX; i++)
		if ((X & bit[i]) > 0)
			for (j = 0; j < BMAX; j++)
				if ((Y & bit[j]) > 0) {
					//fprintf(stderr, "i=%d X=%llu j=%d Y=%llu\n", i, X, j, Y);
					result = (result + bitmod[i + j]) % C;
				}
	return result;
}

unsigned long long raise_to_pow() {
	unsigned long long result = 1 % C;

	for (int b = BMAX - 1; b >= 0; b--) {
		result = mult(result, result);
		//fprintf(stderr, "b=%d result=%llu\n", b, result);
		if ((B & bit[b]) > 0) {
			result = mult(result, A);
			//fprintf(stderr, "*b=%d result=%llu\n", b, result);
		}
	}

	return result;
}

int main() {
	freopen("classictask.in", "r", stdin);
	scanf("%llu %llu %llu", &A, &B, &C);

	compute_bits();

	freopen("classictask.out", "w", stdout);
	printf("%llu\n", raise_to_pow());

	return 0;
}
