// O(n*log n) AIB
// Constantin Galatan
#include <cstdio>
#include <algorithm>
using namespace std;

#define DIM 1000001
#define INF 0x3f3f3f3f

int a[DIM], n;
int AIB[DIM]; // AIB[i] - nr minim de salturi din intervalul [1..i] pana in afara sirului

void Update(int poz, int val) {
    for (int i = poz; i <= n; i += i & -i)
        AIB[i] = min(AIB[i], val);
}

int Query(int poz) {
    int minim = INF;
    for (int i = poz; i > 0; i -= i & -i)
        minim = min(minim, AIB[i]);
    return minim;
}

int main()
{
    freopen("salturi.in", "r", stdin);
    freopen("salturi.out", "w", stdout);
    scanf("%d", &n);
    for ( int i = 1; i <= n; ++i ) {
        scanf("%d", a + i);
        AIB[i] = INF;
    }

    int i, j, minim;
    for ( i = n; i > 0; --i ) {
        if ( a[i] < 0 ) continue;
        if ( i + a[i] > n )
            Update(i, 1);
        else
            Update(i, 1 + Query(i + a[i]));  // Query(i) == INF (AIB[1]...AIB[i] == INF)
    }
    if ( AIB[1] == INF )
        printf("-1\n");
    else
        printf("%d\n", AIB[1]);
    fclose(stdin);
    fclose(stdout);
    return 0;
}

