#include <fstream>
#include <vector>
#include <algorithm>
using namespace std;

ifstream fin("mario.in");
ofstream fout("mario.out");

struct Segm {
    int h, x, y;
    long long nx, ny;
    Segm() : nx(0), ny(0) { }
    Segm(int _h, int _x, int _y)
        : h(_h), x(_x), y(_y), nx(0), ny(0) { }
    bool operator()(const Segm& s1, const Segm& s2) const
    {
        return s1.h < s2.h || (s1.h == s2.h && s1.y < s2.x);
    }
};

void Calc(long long& nr, int x, int h, int jmax);

vector<Segm> s;
int hM, xM, n, H, a, b, h, x;
long long nM;

int main()
{
    fin >> hM >> xM >> H >> n;
    for ( int i = 0; i < n; ++i )
    {
        fin >> h >> a >> b;
        s.push_back(Segm(h, a, b));
    }

    sort(s.begin(), s.end(), Segm());
    if ( s[0].h < H )
        s[0].nx = s[0].ny = 1;
    for ( int i = 1; i < n; ++i )
    {
        x = s[i].x; h = s[i].h;
        Calc(s[i].nx, x, h, i - 1);
        x = s[i].y;
        Calc(s[i].ny, x, h, i - 1);
    }
    x = xM; h = hM;
    Calc(nM, x, h, n - 1);

    fout << nM << '\n';
    fin.close();
    fout.close();
    return 0;
}

void Calc(long long & nr, int x, int h, int jmax)
{
    bool ok = false;
    for ( int j = jmax; j >= 0; --j )
        if ( s[j].x <= x && s[j].y >= x && h - s[j].h <= H ) // daca gasesc un segment pe care cade
        {
            nr = s[j].nx + s[j].ny;
            ok = true; break;
        }
    if ( !ok && h <= H )  // daca cade direct pe pamant
        nr = 1;
}

