/*
    Constantin Galatan
*/
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

struct Capat {   // capat de interval
    int x;
    int sgn;     // +1 capat stanga, -1 capat dreapta
    Capat(int _x, int _sgn) : x(_x), sgn(_sgn) { }
    friend bool operator < (const Capat& a, const Capat& b)
    {
        return (a.x < b.x) || ((a.x == b.x) && (a.sgn > b.sgn));
    }
};

int n, P, Res;
vector<Capat>  c, C;
bool Try(int x);

int main()
{
    freopen("intervale.in", "r", stdin);
    freopen("intervale.out", "w", stdout);

    scanf("%d %d", &n, &P);
    int a, b;
    for (int i = 0; i < n; i++)
    {
        scanf("%d %d", &a, &b);
        C.push_back(Capat(a, 1));   // capat stanga
        C.push_back(Capat(b, -1));  // capat dreapta
    }

    sort(C.begin(), C.end());
    int cnt = 0, Lmax = 0, L = 0, lf = -1;
    for (int i = 0; i < 2 * n; i++)
    {
        if (cnt == 1 && C[i].sgn == -1)  // se sfarseste un grup
            lf = C[i].x;
        else
            if ( cnt == 0 && C[i].sgn == 1 ) // incepe un interval
            {
                L = C[i].x - lf;
                Lmax = max(Lmax, L);
            }
        cnt += C[i].sgn;
    }

    int left = 0, right = Lmax / 2 + 1, mid;
    while ( left <= right )
    {
        mid = (left + right) / 2;
        if ( Try(mid) )
        {
            Res = mid;
            right = mid - 1;
        }
        else
            left = mid + 1;
    }

    printf("%d\n", Res);
    fclose(stdin);
    fclose(stdout);
    return 0;
}

bool Try(int v)
{
    c = C;
    for ( int i = 0; i < 2 * n; ++i )
        if ( c[i].sgn == 1 )
            c[i].x -= v;
        else
            c[i].x += v;
    sort(c.begin(), c.end());

    int cnt = 0, nr = 0, nrMax = 0;
    for (int i = 0; i < 2 * n; i++)
    {
        if ( c[i].sgn == 1 ) // incepe un interval
        {
            if ( cnt == 0 )   // incepe un grup cu intervalul acesta
                nr = 1;
            else
                nr++;
        }
        else
            if (cnt == 1 )  // se sfarseste un un interval si un grup
                nrMax = max(nrMax, nr);
        cnt += c[i].sgn;
        if ( nrMax >= P ) return true;
    }
    return false;
}

