#include <stdio.h>
#include <math.h>
#include <algorithm>
#include <vector>

using namespace std;

#define NMAX 101
#define eps 1e-6

vector<pair<double, int> > v;
double x[NMAX][NMAX], L1, L2, L3;
int y[NMAX][NMAX];
int cnt[NMAX];
int i, j, k, p;

int main() {
	double dx = 1.0 / sqrt(3.0);
	
	x[1][1] = 0.0;
	y[1][1] = 1;
	v.push_back(make_pair(x[1][1], y[1][1]));

	for (i = 2; i < NMAX; i++) {
		for (j = 1; j <= i - 1; j++) {
			x[i][j] = x[i - 1][j] - dx;
			y[i][j] = y[i - 1][j] + 1;
		}
		
		x[i][i] = x[i - 1][i - 1] + dx;
		y[i][i] = y[i - 1][i - 1] + 1;
		
		for (j = 1; j <= i; j++)
			v.push_back(make_pair(x[i][j], y[i][j]));
	
		fprintf(stderr, "i=%d:", i);
		for (j = 1; j <= i; j++)
			fprintf(stderr, " (%.3lf,%d)", x[i][j], y[i][j]);
		fprintf(stderr, "\n");
	}

	sort(v.begin(), v.end());
	
	for (i = 0; i < v.size(); i++)
		for (j = i + 1; j < v.size(); j++) {
			L1 = (v[i].first - v[j].first) * (v[i].first - v[j].first) +
				  (v[i].second - v[j].second) * (v[i].second - v[j].second);
			for (k = j + 1; k < v.size(); k++) {
				L2 = (v[i].first - v[k].first) * (v[i].first - v[k].first) +
					  (v[i].second - v[k].second) * (v[i].second - v[k].second);
				L3 = (v[j].first - v[k].first) * (v[j].first - v[k].first) +
					  (v[j].second - v[k].second) * (v[j].second - v[k].second);
				if (fabs(L1 - L2) < eps && fabs(L1 - L3) < eps) {
					p = v[i].second;
					if (v[j].second > p)
						p = v[j].second;
					if (v[k].second > p)
						p = v[k].second;
					while (p < NMAX) {
						cnt[p]++;
						p++;
					}
				}
			}
		}
	
	freopen("dd.cpp", "w", stdout);
		
	for (i = 1; i < NMAX; i++) {
		fprintf(stderr, "i=%d: %d\n", i, cnt[i]);
		printf("%d,\n", cnt[i]);
	}

	return 0;
}
