#include <stdio.h>
#include <string.h>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

#define VMAX 9000000000000000000LL
#define SMALL_VMIN 2LL
#define SMALL_VMAX 3000000000LL
#define NMAX 222

long long gcd(long long a, long long b) {
	if (a == 0)
		return b;
	if (b == 0)
		return a;
	return gcd(b, a % b);
}

long long llsqrt(long long x) {
	long long li = SMALL_VMIN, ls = SMALL_VMAX, mid, tmp;
	
	while (li <= ls) {
		mid = (li + ls) / 2;
		tmp = mid * mid;
		if (tmp == x)
			return mid;
		else if (tmp < x) {
			li = mid + 1;
		} else {
			ls = mid - 1;
		}
	}

	return -1;
}

long long v[NMAX], sol[NMAX], x0, xx0, x1, xx1, x2, xx2, d;
vector<long long> p;
set<long long> num;
multiset<long long> prod;
multiset<long long>::iterator it;
int N, i, j, k, ok, L;
char ptmp[100];

int main() {
	int T, te;

//	freopen("x.txt", "r", stdin);
//
	scanf("%d", &T);
	
	for (te = 1; te <= T; te++) {
		scanf("%d", &N);
		k = N * (N - 1) / 2;
		p.resize(k);
		for (i = 0; i < k; i++) {
			scanf("%s", ptmp);
			L = strlen(ptmp);
			p[i] = 0;
			for (j = 0; j < L; j++) {
				p[i] = p[i] * 10 + (ptmp[j] - '0');
				if (ptmp[j] < '0' || ptmp[j] > '9')
					return 1;
			}
			//scanf("%lld", &(p[i]));
		}
	
		sort(p.begin(), p.end());
		for (sol[0] = 0, k = 2; /*k < 2 + N &&*/ k < p.size(); k++) {
			xx0 = x0 = p[0];
			xx1 = x1 = p[1];
			xx2 = x2 = p[k];
			d = gcd(xx0, xx1);
			xx0 /= d;
			xx1 /= d;
			d = gcd(xx0, xx2);
			xx0 /= d;
			xx2 /= d;

			if (xx0 != 1)
				continue;

			if (VMAX / xx1 < xx2)
				continue;
			xx1 *= xx2;
			
			v[2] = llsqrt(xx1);

			if (v[2] < SMALL_VMIN || v[2] > SMALL_VMAX)
				continue;
			
			if ((x1 % v[2]) > 0)
				continue;
			v[0] = x1 / v[2];
			if (v[0] < SMALL_VMIN || v[0] > SMALL_VMAX)
				continue;
			if ((x0 % v[0]) > 0)
				continue;
			v[1] = x0 / v[0];
			if (v[1] < SMALL_VMIN || v[1] > SMALL_VMAX)
				continue;

			//fprintf(stderr, "%lld %lld %lld\n", v[0], v[1], v[2]);

			// Try to find the remaining numbers.
			num.clear();
			num.insert(v[0]);
			num.insert(v[1]);
			num.insert(v[2]);

			//if (num.size() != 3)
			//	continue;

			prod.clear();
			for (j = 2; j < p.size(); j++)
				if (j != k)
					prod.insert(p[j]);
			
			for (i = 3; i < N; i++) {
				it = prod.begin();
				if (((*it) % v[0]) > 0) {
					break;
				}
				v[i] = (*it) / v[0];
				if (v[i] < SMALL_VMIN || v[i] > SMALL_VMAX) {
					//sol[0] = -1;
					break;
				}
				num.insert(v[i]);
				//if (num.size() != i + 1) {
				//	break;
				//}
				
				prod.erase(it);
				for (j = 1; j < i; j++) {
					it = prod.find(v[j] * v[i]);
					if (it == prod.end()) {
						break;
					}
					prod.erase(it);
				}
				
				if (j < i) {
					break;
				}
			}

			if (i < N)
				continue;

			if (prod.size() != 0)
				return 1;

			//for (i = 0; i < N; i++)
			//	fprintf(stderr, " %lld", v[i]);
			//fprintf(stderr, "\n");

			//for (i = 1; i < N; i++)
			//	if (v[i] <= v[i - 1])
			//		break;

			if (i < N)
				continue;
		
			ok = 0;
			if (sol[0] <= 0)
				ok = 1;
			if (!ok) {
				for (i = 0; i < N; i++)
					if (sol[i] != v[i])
						break;
				if (i < N && v[i] < sol[i])
					ok = 1;
			}
			
			if (ok) {
				for (i = 0; i < N; i++)
					sol[i] = v[i];
			}
		}

		if (sol[0] == 0)
			return 1;

		printf("Case %d:", te);
		for (i = 0; i < N; i++)
			printf(" %lld", sol[i]);
		printf("\n");
	}

	return 0;
}
